<?php
// Hochladen von Backup files, die Datenbank wird angepasst.

include('/usr/local/php/include/confBackup.Class.php');
include('../misc/database.php');
include('../includes/variables.php');
require_once('../includes/Helper/Helper.php');
require_once('/usr/local/www/berogui/includes/session.php');
include_once ('/usr/local/php/include/restore.Class.php');
// Do the new thing.
include('/usr/php/include/configExportImportTool.class.php');


$fileName = $_FILES['uploadfile']['name'];
$tempFile = $_FILES['uploadfile']['tmp_name'];

if (strstr($fileName, '.config.xml')) {
	$imp = new configExportImportTool($tempFile);
	//import config files
	if($_POST['configFiles'] || $_POST['importOptions']['tls']){
		$configFiles = $imp->fileGroupsToFiles($_POST['configFiles']);
		if ($_POST['configFiles']==null) $configFiles = array();
		else ($configFiles = $_POST['configFiles']);
		if($_POST['importOptions']['tls']==null) $importOptions =array();
		else $importOptions = $_POST['importOptions'];
		$answ = $imp->import($configFiles,$importOptions);
		if ($answ===false) {
			echo '<script>alert(\'Failed!!\')</script><script>window.location=\'../index.php?m=BackupRestore\';</script>';
			exit(0);
		}
		if($_POST['importOptions']['tls'] &&!rootHelper::tlsCheckCertificate()){
			echo '<script>alert(\'!!Warning!!\n\ntls certificates are not configured correctly\')</script><script>window.location=\'../index.php?m=BackupRestore\';</script>';
		}
	}	
	// go over appConfigFiles
	if (($appConfigFiles = $imp->getAppConfigFiles()) !== false &&$_POST['importOptions']['appConfig']==true) {
		foreach ($appConfigFiles as $app) {
			@mkdir('/usr/conf/userapp/' . $app['name']);
			if (empty($app['files'])) {
				continue;
			}
			foreach ($app['files'] as $appFile) {
				switch ($appFile['mode']) {

					case 'directory':	system('/bin/mkdir -p /usr/conf/userapp/' . $appFile['name']);	break;
					case 'binary':		$fileData = base64_decode($appFile['content']);					break;
					default:			$fileData = $appFile['content'];								break;
				}

				if ($appFile['mode'] != 'directory') {
					@unlink('/usr/conf/userapp/' . $appFile['name']);
					$FP = fopen('/usr/conf/userapp/' . $appFile['name'], 'w');
					fwrite($FP, $fileData, strlen($fileData));
					fclose($FP);
					$FP = null;
					unset($fileData);
				}

				system('/bin/chown admin:admin /usr/conf/userapp/' . $appFile['name']);
			}
		}
	}

	$restore=new restoreConfig(0);

	if (!$restore->restoreConfig()){
		echo str_replace(array("\r\n", "\n", "\r"), '<br />', $restore->getLog());
		exit(1);
	}
	Helper::activate(3);
	echo '<script>window.location=\'../index.php?m=BackupRestore\';</script>';
	exit(0);
	
} else if (strstr($fileName, '.xml')) {
	echo "<script>alert('Please update a \'.config.xml\' file generated by a beroNet device.'); window.location='../index.php?m=BackupRestore';</script>";
	exit(0);
}

// Do the old thing
$cb = new confBackup();

switch ($cb->verifyFileName($fileName)) {
case 0:			// invalid filename
	$js_txt =	'The uploaded file \'' . $fileName . '\' is not a valid configuration-backup!';
	echo "<script>alert(\"" . $js_txt . "\"); window.location='../index.php?m=BackupRestore';</script>";
	exit(0);
case 1:			// single conf-file
	if ($cb->installConfFile($fileName, $tempFile) == false) {
	     	echo '<script>alert(\'Failed!!\')</script>';
	}

	break;
case 2:			// tar.gz with different name
	$js_txt =	'The uploaded file \'' . $fileName . '\' seems not to be a backup of the configuration of this beroNet Gateway.' . "\n" .
			'Are you sure you want to proceed to restore this backup file?';
	echo 	'<script type="text/javascript">' . "\n" .
		'if (confirm(\'' . $js_txt . '\') == false) {' . "\n" .
		'window.location=\'../index.php?m=BackupRestore\';' . "\n" .
		'}' . "\n" .
		'</script>' . "\n";
case 3:			// tar.gz with fitting name
	if ($cb->installFullBackup($fileName, $tempFile) == false) {
		echo '<script>alert(\'Failed!!\')</script>';
	}
	break;
}

$cb->installCleanup();
@unlink('/tmp/' . $fileName);

Helper::activate(3);
echo '<script>window.location=\'../index.php?m=BackupRestore\';</script>';

?>